# coding: utf-8

module UzuUzu
  module Controller
    include ::UzuUzu::Helper::Controller
    require 'uzuuzu-core/controller/index'
    module Login
      require 'uzuuzu-core/controller/login/facebook'
      require 'uzuuzu-core/controller/login/google'
      require 'uzuuzu-core/controller/login/twitter'
    end
    
    def self.current
      Thread.current[:controller]
    end
    
    def self.before_all
      ::UzuUzu.logger.debug "params : #{::UzuUzu::Request.current.params}"
    end
    
    def self.after_all
    end
  end # Controller
end # UzuUzu
