# coding: utf-8

module UzuUzu
  module Helper
    module XHtml
      
      #
      #
      #
      def meta(name, content)
        "<meta name=\"#{name}\" content=\"#{content}\">"
      end
      #
      #
      #
      def css(css_path, media='screen')
        "<link href=\"#{css_path}\" media=\"#{media}\" rel=\"stylesheet\" type=\"text/css\" />"
      end
      #
      #
      #
      def css_for(*args)
        args.map do |css_path|
          css(css_path)
        end.join("\n")
      end
      #
      #
      #
      def js(js_path)
        "<script src=\"#{js_path}\" type=\"text/javascript\"></script>"
      end
      #
      #
      #
      def js_for(*args)
        args.map do |js_path|
          js(js_path)
        end.join("\n")
      end

    end
  end
end