# coding: utf-8

module UzuUzu
  module Wrapper
    #
    #
    #
    class Wrapper
      #
      attr_reader :wrapper
      #
      #
      #
      def initialize(wrapper, env=nil)
        unless env && env['adapter']
          return
        end
        @env = env.clone
        begin
          adapter = @env['adapter']
          require "uzuuzu-core/#{wrapper}/#{adapter}"
          adapter_class = eval("::UzuUzu::#{wrapper.camel_case}::#{adapter.camel_case}")
          @wrapper = adapter_class.new(@env)
        rescue => e
          $stderr.puts "#{wrapper} create error"
          $stderr.puts e
          $stderr.puts e.backtrace
        end
      end
    end # Wrapper
  end # Wrapper
end # UzuUzu