# coding: utf-8

module UzuUzu
  #
  #
  #
  module Helper
    #
    #
    #
    module Controller
      #
      #
      #
      def logger
        ::UzuUzu.logger
      end
      
      #
      #
      #
      def application
        ::UzuUzu.current
      end
      
      #
      #
      #
      def controller
        ::UzuUzu.controller
      end
      
      #
      #
      #
      def request
        ::UzuUzu.request
      end
  
      #
      #
      #
      def response
        ::UzuUzu.response
      end
      
      #
      #
      #
      def helper
        ::UzuUzu.helper
      end
      
      #
      #
      #
      def action
        Thread.current[:action]
      end
      
      #
      #
      #
      def query
        Thread.current[:query]
      end
      
      #
      #
      #
      def route
        Thread.current[:route]
      end
  
      #
      #
      #
      def session
        request.session
      end
      
      #
      #
      #
      def dm
        ::UzuUzu.dm
      end
      
      #
      #
      #
      def s3
        ::UzuUzu.s3
      end
      
      #
      #
      #
      def h(s)
        Rack::Utils.escape(s)
      end
      
      #
      #
      #
      def u(s)
        Rack::Utils.unescape(s)
      end
      
      #
      #
      #
      def query_string(query_options={})
        return "" if query_options.blank?
        query_string = []
        query_options do |key, value|
          query_string << "#{key}=#{value}"
        end
        return "" if query_string.blank?
        "?#{query_string.join('&')}"
      end
      
      #
      #
      #
      def instance_variable_map(instance)
        map = {}
        instance.instance_variables.each do |variable_name|
          map[variable_name] = instance.instance_variable_get(variable_name)
        end
        map
      end
    end # Controller
  end # Helper
end # UzuUzu