# coding: utf-8

#
#
#
module UzuUzu
  Apps = {}
  
  #
  def app
    if Apps.blank?
      Application.new
    end
    app = {}
    Apps.each do |key, value|
      rack_session = value.environments.rack_session
      static = Rack::Static.new(value, :urls => ['/'], :root => 'public')
      if key == :uzuuzu
        app['/'] = rack_session.app(Rack::Cascade.new([static, value]))
      else
        app["/#{key}"] = rack_session.app(Rack::Cascade.new([static, value]))
      end
    end
    Rack::URLMap.new(app)
  end
  
  #
  def current
    Application.current
  end
  
  def apps
    Apps
  end
  
  #
  def logger
    Environments.current.logger
  end

  #
  def dm
    Environments.current.dm
  end

  #
  def s3
    Environments.current.s3
  end

  #
  def memcache
    Environments.current.memcache
  end

  def localize
    Environments.current.localize
  end
  
  def controller
    Controller.current
  end

  def helper
    Helper.current
  end
  
  def request
    Request.current
  end
  
  def response
    Response.current
  end
  
  #
  def render_engine(instance, view_string, engine='erb', options={}, locals={}, &block)
    Tilt.render_engine(instance, view_string, engine, options, locals, &block)
  end
  
  extend self
end # UzuUzu