# coding: utf-8

module UzuUzu
  module Wrapper
    #
    #
    #
    class Logger
      #
      attr_reader :logger
      #
      #
      #
      def initialize(env=nil)
        begin
          if env.nil? || env.kind_of?(Array) || env['adapter'].nil?
            require 'uzuuzu-core/logger/loggers'
            @logger = ::UzuUzu::Logger::Loggers.new(env)
          else
            adapter = env['adapter']
            require "uzuuzu-core/logger/#{adapter}"
            adapter_class = eval("::UzuUzu::Logger::#{adapter.camel_case}")
            @logger = adapter_class.new(env)
          end
        rescue => e
          $stderr.puts 'logger create error'
          $stderr.puts e
          $stderr.puts e.backtrace
        end
      end # initialize
      
    end # Logger
  end # Wrapper
end # UzuUzu